from sasktran2.tests.rtm_comparison import load_scenario
import sasktran2 as sk
from copy import copy
import numpy as np


def test_all_rtm_comparison_ss():
    for atm_scenario in range(2):
        for geo_scenario in range(9):
            scen = load_scenario(geo_scenario, atm_scenario, 0, 0, 16, altitude_spacing=500)

            engine = sk.Sasktran(scen['config'], scen['geometry'], scen['viewinggeo'])

            output = engine.calculate(scen['atmosphere'])

            rad = output['radiance']

            # Currently the Q/U convention is negative that of the RTM intercomparison
            rad[:, :, 1:3] *= -1

            # The SCIATRAN single scatter results seem to be the best
            scia_vals = scen['result']['radiance'].isel(model=2).values[:, :, :3]

            p_diff = (scia_vals - rad) / scia_vals * 100

            max_error = np.max(np.abs(p_diff.flatten()))

            assert(max_error < 0.2)
